/*
 ============================================================================
 Project     : Fitness Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "validate_input.c"

int TAMANHO_CAPPEPLUS;
int * genomeCappedMinus;
int * genomeCappedPlus;
void set_TAMANHO_CAPPEPLUS(int entrada[], int size){
   
 int *estatusA=status_A(entrada, size);//vem do arquivo validaentrada.c
if (estatusA==NULL) {
    printf("ATENCAO PERCA DE MEMORIA, DadosAdicionais.C, LINE 22\n");
}
    
 int k;
 TAMANHO_CAPPEPLUS=0;
   
//qtd_cromossomo e global do arquivo validaentrada.c
 for(k=0; k<qtd_cromossomo; k++)
  {
    
      
        TAMANHO_CAPPEPLUS=TAMANHO_CAPPEPLUS + estatusA[k]+2;
  }

    
    
    genomeCappedMinus= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (genomeCappedMinus==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, DadosAdicionais.C, LINE 40\n");
    }
    
    genomeCappedPlus= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    if (genomeCappedPlus==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, DadosAdicionais.C, LINE 45\n");
    }
    
 free(estatusA);
}


void cappingP(int entrada[], int size)
{   

   // int *a;
    int *estatusA=status_A(entrada, size);
    if (estatusA==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, DadosAdicionais.C, LINE 58\n");
    }
    int i=0;
    int k=0;
	
    
  //  a= (int *) calloc (TAMANHO_CAPPEPLUS, sizeof (int));
    memset(genomeCappedPlus,0,TAMANHO_CAPPEPLUS);
    int cont2=0;
	
    for (; i<qtd_cromossomo;i++) {
     
        for(k=0; k<estatusA[i]; k++) {
            if(k==0)
            {
                genomeCappedMinus[cont2]=0;
                cont2++;
            }
            
            genomeCappedPlus[cont2]=GENOMA_A[i][k];
            
            cont2++;
            if(k+1 == estatusA[i])
            {
                genomeCappedPlus[cont2]=qtd_genes+1;
                 cont2++;
            }
            
        }
    }
    
   free(estatusA);
   // return a;
}//fim complementar





void cappingM(int entrada[], int size)
{   
   
   
    int i=0;
    int k=0;
    int *estatusA=status_A(entrada, size);
    if (estatusA==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, DadosAdicionais.C, LINE 105\n");
    }
    memset(genomeCappedMinus,0,TAMANHO_CAPPEPLUS);

    int cont2=0;
	
    for (; i<qtd_cromossomo;i++) {
        for(k=0; k<estatusA[i]; k++) {
            if(k==0)
            {
                genomeCappedMinus[cont2]=-1* (qtd_genes+1);
                cont2++;
            }
            
             genomeCappedMinus[cont2]=GENOMA_A[i][k];
            
            cont2++;
            if(k+1 == estatusA[i])
            {
            	genomeCappedMinus[cont2]=0;
                cont2++;
            }
            
        }
          
    }
    free(estatusA);
//return b;
}//fim complementar


/*
int main(){

   // usa-se o 0 para separar os cromossomos no genoma
    int entrada[11]={4,3,0,1,2,-7,5,0,6,-8,9};
    int entrada2[11]={1,2,3,0,4,5,0,6,7,8,9};
    
  printf("Saida: %d \n", cromossomo(entrada,entrada2, (sizeof(entrada)/sizeof(int)),(sizeof(entrada2)/sizeof(int))));
   //referente ao arquivo.c
   printf("saida:%d\n",is_cotail( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)))); 
   load_genoma( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)));
    fim das funcoes arquivo.c
    
   set_TAMANHO_CAPPEPLUS(entrada,(sizeof(entrada)/sizeof(int)));
 
 printf("\n");

return 0;

}
*/

