#include <stdio.h>
#include <stdlib.h>



//using 1 islands
int * tree24(int indice)
{
    int * vizinhos=(int*)calloc(4, sizeof(int));
    vizinhos[0]=-1;
    vizinhos[1]=-1;
    vizinhos[2]=-1;
    vizinhos[3]=-1;
    
    switch (indice) {
        case 0:
            vizinhos[0]=1;
            vizinhos[1]=2;
        break;
        case 1:
            vizinhos[0]=0;
            vizinhos[1]=3;
            vizinhos[2]=4;
        break;
        case 2:
            vizinhos[0]=0;
            vizinhos[1]=5;
            vizinhos[2]=6;
        break;
        case 3:
            vizinhos[0]=1;
            vizinhos[1]=7;
            vizinhos[2]=8;
        break;
        case 4:
            vizinhos[0]=1;
            vizinhos[1]=9;
            vizinhos[2]=10;
        break;
        case 5:
            vizinhos[0]=2;
            vizinhos[1]=11;
            vizinhos[2]=12;
        break;
        case 6:
            vizinhos[0]=2;
            vizinhos[1]=13;
            vizinhos[2]=14;
        break;
        case 7:
            vizinhos[0]=3;
            vizinhos[1]=15;
        break;
        case 8:
            vizinhos[0]=3;
            vizinhos[1]=16;
        break;
        case 9:
            vizinhos[0]=4;
            vizinhos[1]=17;
        break;
        case 10:
            vizinhos[0]=4;
            vizinhos[1]=18;
        break;
        case 11:
            vizinhos[0]=5;
            vizinhos[1]=19;
        break;
        case 12:
            vizinhos[0]=5;
            vizinhos[1]=20;
        break;
        case 13:
            vizinhos[0]=6;
            vizinhos[1]=21;
        break;
        case 14:
            vizinhos[0]=6;
            vizinhos[1]=22;
        break;
        case 15:
            vizinhos[0]=7;
        break;
        case 16:
            vizinhos[0]=8;
        break;
        case 17:
            vizinhos[0]=9;
        break;
        case 18:
            vizinhos[0]=10;
        break;
        case 19:
            vizinhos[0]=11;
        break;
        case 20:
            vizinhos[0]=12;
        break;
        case 21:
            vizinhos[0]=13;
        break;
        case 22:
            vizinhos[0]=14;
            vizinhos[1]=23;
        break;
        case 23:
	    vizinhos[0]=22;
        break;
    }//end switch
    return vizinhos;
}// tree24

int * tree12(int indice)
{
    
    int * vizinhos=(int*)calloc(4, sizeof(int));
    vizinhos[0]=-1;
    vizinhos[1]=-1;
    vizinhos[2]=-1;
    vizinhos[3]=-1;
    switch (indice) {
        case 0:
            vizinhos[0]=1;
            vizinhos[1]=2;
        break;
            
        case 1:
            vizinhos[0]=0;
            vizinhos[1]=3;
            vizinhos[2]=4;
        break;
            
        case 2:
            vizinhos[0]=0;
            vizinhos[1]=5;
            vizinhos[2]=6;
        break;
        case 3:
            vizinhos[0]=1;
            vizinhos[1]=7;
            vizinhos[2]=8;
        break;
        case 4:
            vizinhos[0]=1;
            vizinhos[1]=9;
        break;
        case 5:
            vizinhos[0]=2;
            vizinhos[1]=10;
        break;
        case 6:
            vizinhos[0]=2;
            vizinhos[1]=11;
        break;
        case 7:
            vizinhos[0]=3;
        break;
        case 8:
            vizinhos[0]=3;
        break;
        case 9:
            vizinhos[0]=4;
        break;
        case 10:
            vizinhos[0]=5;
        break;
        case 11:
            vizinhos[0]=6;
        break;
    }//end switch

    return vizinhos;

}//end tree12


//using 24 islands
int * celullar24(int indice)
{
	int * vizinhos=(int*)calloc(4, sizeof(int));
	vizinhos[0]=-1;
	vizinhos[1]=-1;
	vizinhos[2]=-1;
	vizinhos[3]=-1;

	switch(indice)
	{
		case 0:
			vizinhos[0]=7;
			vizinhos[1]=5;
		break;

		case 1:
			vizinhos[0]=6;
			vizinhos[1]=8;
			
		break;
		case 2:
			vizinhos[0]=7;
			vizinhos[1]=9;
		break;

		case 3:
			vizinhos[0]=8;
			vizinhos[1]=10;
		break;
		case 4:
			vizinhos[0]=9;
			vizinhos[1]=11;
		break;
		case 5:
			vizinhos[0]=10;
			vizinhos[1]=0;
		break;
		case 6:
			vizinhos[0]=1;
			vizinhos[1]=13;
		break;
		case 7:
			vizinhos[0]=0;
			vizinhos[1]=2;
			vizinhos[2]=12;
			vizinhos[3]=14;
		break;
		case 8:
			vizinhos[0]=1;
			vizinhos[1]=3;
			vizinhos[2]=13;
			vizinhos[3]=15;
		break;

		case 9:
			vizinhos[0]=2;
			vizinhos[1]=4;
			vizinhos[2]=14;
			vizinhos[3]=16;
		break;
		case 10:
			vizinhos[0]=3;
			vizinhos[1]=5;
			vizinhos[2]=15;
			vizinhos[3]=17;
		break;
		case 11:
			vizinhos[0]=4;
			vizinhos[1]=16;
		break;
		case 12:
			vizinhos[0]=7;
			vizinhos[1]=19;
		break;
		case 13:
			vizinhos[0]=6;
			vizinhos[1]=8;
			vizinhos[2]=18;
			vizinhos[3]=20;
		break;
		case 14:
			vizinhos[0]=7;
			vizinhos[1]=9;
			vizinhos[2]=19;
			vizinhos[3]=21;
		break;

		case 15:
			vizinhos[0]=8;
			vizinhos[1]=10;
			vizinhos[2]=20;
			vizinhos[3]=22;
		break;
		case 16:
			vizinhos[0]=9;
			vizinhos[1]=11;
			vizinhos[2]=21;
			vizinhos[3]=23;
		break;
		case 17:
			vizinhos[0]=10;
			vizinhos[1]=22;
		break;
		case 18:
			vizinhos[0]=13;
			vizinhos[1]=23;
		break;
		case 19:
			vizinhos[0]=12;
			vizinhos[1]=14;
		break;
		case 20:
			vizinhos[0]=13;
			vizinhos[1]=15;
		break;
		case 21:
			vizinhos[0]=14;
			vizinhos[1]=16;
		break;
		case 22:
			vizinhos[0]=15;
			vizinhos[1]=17;
		break;
		case 23:
			vizinhos[0]=16;
			vizinhos[1]=18;
		break;

	}//end switch

	return vizinhos;

}//end celullar

/*
int main()
{
	int *a= tree24(23);
	int i;
	for (i = 0; i < 4; ++i)
{
	if (a[i]==-1)
		break;
	else
		printf("%d \n", a[i]);
}//end for
free(a);
	return 0;
}

*/
