#include <stdio.h>
#include <stdlib.h>





void insertion_sort(int vetor[], int size) {

int escolhido, j, i;

    for (i = 1; i < size; i++) {
		escolhido = vetor[i];
		j = i - 1;
		
		while ((j >= 0) && (vetor[j] > escolhido)) {
			vetor[j + 1] = vetor[j];
			j--;
		}
		
		vetor[j + 1] = escolhido;
	}
}




/*!
     * \brief Sets the number of queens in the cost calculator.
     * \param numberOfQueens Number of queens in the problem.
     */
   

    int calculateCostFunction(int input[], int numberOfQueens)
    {

        int leftDiagonals = 0;
        int rightDiagonals = 0;
        int up=0;
        int i,j;
       
       
       int * f1= (int *) calloc (numberOfQueens, sizeof (int));
       int * f2= (int *) calloc (numberOfQueens, sizeof (int));
       
        for ( i = 0; i < numberOfQueens; i++) 
        {
            f1[i] = input[i] - i;
            f2[i] = (numberOfQueens) - input[i] - i;
        }

       insertion_sort(f1, numberOfQueens);
       insertion_sort(f2, numberOfQueens);

        for (i = 1; i < numberOfQueens; i++) {
            if (f1[i] == f1[i - 1]) {
                leftDiagonals++;
            }
            if (f2[i] == f2[i - 1]) {
                rightDiagonals++;
            }
		if (input[i] == input[i - 1]) {
                	up++;
            }
        }

       

        free(f1);
        free(f2);
        
        
        return leftDiagonals + rightDiagonals+up;
    }


/*
int main(){

 int a [3]={0,1,0};

printf("%d \n", calculateCostFunction(a, 3));

}
*/
