#include <stdio.h>
#include <stdlib.h>



//passa um valor e retorna as suas ligacoes
int * net6x4(int indice)
{

    int * vizinhos=(int*)calloc(4, sizeof(int));
    vizinhos[0]=-1;
    vizinhos[1]=-1;
    vizinhos[2]=-1;
    vizinhos[3]=-1;

	switch(indice)
	{
		case 0:
			vizinhos[0]=1;
			vizinhos[1]=3;
			vizinhos[2]=4;
		break;

		case 1:
			vizinhos[0]=0;
			vizinhos[1]=2;
			vizinhos[2]=5;
		break;

		case 2:
			vizinhos[0]=1;
			vizinhos[1]=3;
			vizinhos[2]=6;
		break;

		case 3:
			vizinhos[0]=0;
			vizinhos[1]=2;
			vizinhos[2]=7;
		break;

		case 4:
			vizinhos[0]=0;
			vizinhos[1]=5;
			vizinhos[2]=8;
			vizinhos[3]=7;
		break;

		case 5:
			vizinhos[0]=4;
			vizinhos[1]=1;
			vizinhos[2]=6;
			vizinhos[3]=9;
		break;

		case 6:
			vizinhos[0]=2;
			vizinhos[1]=10;
			vizinhos[2]=5;
			vizinhos[3]=7;
		break;

		case 7:
			vizinhos[0]=3;
			vizinhos[1]=6;
			vizinhos[2]=11;
			vizinhos[3]=4;
		break;

		case 8:
			vizinhos[0]=4;
			vizinhos[1]=9;
			vizinhos[2]=11;
		break;

		case 9:
			vizinhos[0]=5;
			vizinhos[1]=8;
			vizinhos[2]=10;
		break;

		case 10:
			vizinhos[0]=6;
			vizinhos[1]=9;
			vizinhos[2]=11;
		break;

		case 11:
			vizinhos[0]=7;
			vizinhos[1]=10;
			vizinhos[2]=8;
		break;

    }//end switch
    return vizinhos;

}//end toru3x4

//passa um valor e retorna as suas ligacoes
int * net4x3(int indice)
{
    int * vizinhos=(int*)calloc(4, sizeof(int));
    vizinhos[0]=-1;
    vizinhos[1]=-1;
    vizinhos[2]=-1;
    vizinhos[3]=-1;

    switch(indice)
    {
        case 0:
            vizinhos[0]=1;
            vizinhos[1]=3;
            vizinhos[2]=9;
        break;
        case 1:
            vizinhos[0]=0;
            vizinhos[1]=4;
            vizinhos[2]=2;
        break;
        case 2:
            vizinhos[0]=1;
            vizinhos[1]=5;
            vizinhos[2]=11;
        break;
        case 3:
            vizinhos[0]=0;
            vizinhos[1]=4;
            vizinhos[2]=6;
        break;
        case 4:
            vizinhos[0]=1;
            vizinhos[1]=5;
            vizinhos[2]=3;
            vizinhos[3]=7;
        break;
        case 5:
            vizinhos[0]=2;
            vizinhos[1]=4;
            vizinhos[2]=8;
        break;
        case 6:
            vizinhos[0]=3;
            vizinhos[1]=7;
            vizinhos[2]=9;
        break;
        case 7:
            vizinhos[0]=6;
            vizinhos[1]=4;
            vizinhos[2]=10;
            vizinhos[3]=8;
        break;
        case 8:
            vizinhos[0]=7;
            vizinhos[1]=5;
            vizinhos[2]=11;
        break;
        case 9:
            vizinhos[0]=0;
            vizinhos[1]=6;
            vizinhos[2]=10;
        break;
        
        case 10:
            vizinhos[0]=7;
            vizinhos[1]=9;
            vizinhos[2]=11;
        break;
        
        case 11:
            vizinhos[0]=2;
            vizinhos[1]=8;
            vizinhos[2]=10;
        break;

    }//end switch

return vizinhos;


}//end toru4x3
/*
int main(){

int *a =Toru3x4(11);
int i=0;
for(;i<4; i++)
{
	if(a[i]==-1)
		break;
	printf("%d\n",a[i]);
}
free(a);
return 0;

}

*/

