//
//  structure.h
//  
//
//  Created by Lucas Angelo on 01/06/15.
//
//

#ifndef _structure_h
#define _structure_h
#define MAX_N 1000
typedef struct{
    int *pi;/**genome**/
    //int identidade[MAX_N];
    int size; /**size of population**/
}permutation;
//one permutation contain two or more chromosomes separate by zero


typedef struct{
    int genes[MAX_N];
    int fitness;
    int size;
}msgGenome;

typedef struct{
    int index;
    int result;
}msgFitness;


typedef struct{
    int idP;//id do processo
    float MediaVariancia;//valor da media combinado com a variancia
}Coord;

typedef struct{
    int *genes;
    int size;
    int fitness;
}Genome;// here, we go represent the genome with crhormosome separate by zero antes era Chromossome

typedef struct{
	Genome *genome; // chromossomes
	int sizePopulation;//tamanho de la population, con indice base en 0
	int limiteSelection;//Top 50%
	int baseReplace;//A partir de onde se da as substituicoes
    int limiteBusqLocal;//Top 5%
    
	int basePopulation;//base de population atual
	int topPopulation;//top de population atual
    
	int baseDescendencia;//base of descendencia
	int topeDescendencia;//tope of descendencia
    
	int sizeTotal;//tamanho total = 2 * tamanhoPopulation 
}population;





#endif
